SystemOrganization addCategory: #HangmanRescue!

Object subclass: #HangmanSaver
	instanceVariableNames: 'currentState usedLetters vocabulary'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HangmanRescue'!

!HangmanSaver classSide methodsFor: 'as yet unclassified' stamp: 'hjo 1/30/2009 16:21'!
howToUse

	HangmanSaver new.  "open an inspector."
	
	"In that inspector, do the following."
	
	"initializing"
	self resetWithLength: 6.  "cmd+p  returns a string of empty currentState. Copy it to argument of following message."

	self currentState: '______'. "cmd+d"
	self useRecommendedLetter. "cmd+p to get a letter"
	
	"apply the letter to a hangman game and see what is happening."
	self currentState: '_A__A_'. "cmd+d the result of hangman game."! !

!HangmanSaver methodsFor: 'accessing' stamp: 'hjo 1/26/2009 15:40'!
currentState

	^currentState! !

!HangmanSaver methodsFor: 'accessing' stamp: 'hjo 1/26/2009 15:40'!
currentState: aByteString 

	currentState := aByteString! !

!HangmanSaver methodsFor: 'learning' stamp: 'hjo 1/29/2009 22:26'!
defaultVocabulary

	^OrderedCollection new
		add: 'GLIMPSE';
		add: 'NECESSITY';
		add: 'THERMOSTAT';
		add: 'ZUCCHINI';
		add: 'SPREADSHEET';
		add: 'ORANGE';
		add: 'PHYSICIAN';
		add: 'MATHEMATICAL';
		add: 'STRIKEOUT';
		add: 'TORTUROUS';
		add: 'INCONVENIENT';
		add: 'TROUBLEMAKER';
		add: 'AFRICA';
		add: 'FRIGHTFUL';
		add: 'GALORE';
		add: 'GUARDRAIL';
		add: 'EVOLUTION';
		add: 'GORGEOUS';
		add: 'MINIATURE';
		add: 'RIDICULOUS';
		add: 'EARTHQUAKE';
		add: 'ENTHUSIASTIC';
		add: 'HOOLIGAN';
		add: 'MOMENTOUS';
		add: 'HUMIDIFIER';
		add: 'INITIALIZE';
		add: 'YESTERDAY';
		add: 'MUCKRAKER';
		add: 'YUMMY';
		add: 'GINGERBREAD';
		add: 'EXTERMINATE';
		add: 'SOVEREIGN';
		add: 'DEMYSTIFY';
		add: 'OMNIPOTENT';
		add: 'STYMIED';
		add: 'OPPOSITE';
		add: 'EFFECTIVE';
		add: 'OPPRESSION';
		add: 'HIBERNATE';
		add: 'ILLUSTRATE';
		add: 'XENOPHOBE';
		add: 'THREADBARE';
		add: 'TIMESHARE';
		add: 'WONDERFUL';
		add: 'NUMEROLOGY';
		add: 'ATTENUANT';
		add: 'OSMOSIS';
		add: 'PLEASURE';
		add: 'OBJECTION';
		add: 'FORTUNATE';
		add: 'REMORSEFUL';
		add: 'CYCLE';
		add: 'PURVEYOR';
		add: 'INFLECTION';
		add: 'SPHERICAL';
		add: 'INSURGENCE';
		add: 'HYPOTHESIS';
		add: 'EQUESTRIAN';
		add: 'PERPETUITY';
		add: 'BOOMERANG';
		add: 'AFGHANISTAN';
		add: 'GIGAHERTZ';
		add: 'VITAMIN';
		add: 'OKLAHOMA';
		add: 'WHISPER';
		add: 'OCTOPUS';
		add: 'DETRIMENTAL';
		add: 'FRACTURE';
		add: 'TABERNACLE';
		add: 'ZODIAC';
		add: 'DISTRACTION';
		add: 'RESOURCEFUL';
		add: 'FREQUENCY';
		add: 'ENUNCIATE';
		add: 'AMERICA';
		add: 'MAELSTROM';
		add: 'ARMAGEDDON';
		add: 'TECHNOLOGY';
		add: 'SUSPICIOUS';
		add: 'JUXTAPOSE';
		add: 'SPECTRUM';
		add: 'TRANSIENT';
		add: 'EXTRAVAGANT';
		add: 'HELICOPTER';
		add: 'GUIDELINE';
		add: 'WATERPROOF';
		add: 'CURVATURE';
		add: 'OPPORTUNITY';
		add: 'ETHICAL';
		add: 'FREETHINKER';
		add: 'WASHCLOTH';
		add: 'INDEPENDENT';
		add: 'CHEMISTRY';
		add: 'FRUITION';
		add: 'ORTHOPEDIC';
		add: 'FLUORESCENCE';
		add: 'NOMENCLATURE';
		add: 'RACKETEER';
		add: 'DYNASTY';
		add: 'NOTORIETY';
		add: 'PICTURE';
		add: 'DUPLICITOUS';
		add: 'BEHOOF';
		add: 'EPISODIC';
		add: 'PROTOTYPE';
		add: 'PROTRACTED';
		add: 'OBLIGATE';
		add: 'BEGRUDGE';
		add: 'OBTAINABLE';
		add: 'CONGRATULATE';
		add: 'VIGOROUSLY';
		add: 'VACUUM';
		yourself! !

!HangmanSaver methodsFor: 'learning' stamp: 'hjo 1/29/2009 19:50'!
lettersSortedByOccurrence

	| bag |
	bag := Bag new.
	self vocabulary do: [:string| bag addAll: string].
	^'ABCDEFGHIJKLMNOPQRSTUVWXYZ' asSortedCollection: [:a :b| (bag occurrencesOf: a) >= (bag occurrencesOf: b) ]! !

!HangmanSaver methodsFor: 'algorithm' stamp: 'hjo 1/29/2009 19:14'!
recommendALetter

	| candidates |
	candidates := self vocabularyMatchingCurrentState.
	^candidates isEmpty 
		ifTrue: [ (self lettersSortedByOccurrence copyWithoutAll: self usedLetters) first ]
		ifFalse: [ self selectALetterFromCandidates: candidates ]! !

!HangmanSaver methodsFor: 'initialize-release' stamp: 'hjo 1/29/2009 19:20'!
reset

	usedLetters := nil.
	vocabulary := nil.! !

!HangmanSaver methodsFor: 'initialize-release' stamp: 'hjo 1/29/2009 20:40'!
resetWithLength: aSmallInteger 

	| string |
	string := String new: aSmallInteger withAll: $_.
	self reset.
	self currentState: string.
	^string! !

!HangmanSaver methodsFor: 'algorithm' stamp: 'hjo 1/29/2009 18:34'!
selectALetterFromCandidates: anOrderedCollection 

	^(anOrderedCollection first copyWithoutAll: self usedLetters) first! !

!HangmanSaver methodsFor: 'using a letter' stamp: 'hjo 1/26/2009 15:45'!
useLetter: aCharacter 

	self usedLetters add: aCharacter! !

!HangmanSaver methodsFor: 'using a letter' stamp: 'hjo 1/29/2009 18:21'!
useRecommendedLetter

	| letter |
	letter := self recommendALetter.
	self useLetter: letter.
	^letter! !

!HangmanSaver methodsFor: 'accessing' stamp: 'hjo 1/26/2009 15:45'!
usedLetters

	usedLetters isNil ifTrue: [self usedLetters: OrderedCollection new].
	^usedLetters! !

!HangmanSaver methodsFor: 'accessing' stamp: 'hjo 1/26/2009 15:44'!
usedLetters: anOrderedCollection 

	usedLetters := anOrderedCollection ! !

!HangmanSaver methodsFor: 'accessing' stamp: 'hjo 1/26/2009 15:50'!
vocabulary

	vocabulary isNil ifTrue: [self vocabulary: self defaultVocabulary].
	^vocabulary! !

!HangmanSaver methodsFor: 'accessing' stamp: 'hjo 1/26/2009 15:49'!
vocabulary: anOrderedCollection 

	vocabulary := anOrderedCollection! !

!HangmanSaver methodsFor: 'algorithm' stamp: 'hjo 1/29/2009 19:14'!
vocabularyMatchingCurrentState

	| can | 
	can := self vocabularyOfGivenLength.
	^can select: [:string|
		self currentState with: string allSatisfy: 
			[:stateLetter :candiLetter | 
				stateLetter = 
					((self usedLetters includes: candiLetter)
						ifTrue: [ candiLetter ]
						ifFalse: [ $_ ])
		]]! !

!HangmanSaver methodsFor: 'algorithm' stamp: 'hjo 1/29/2009 17:51'!
vocabularyOfGivenLength

	^self vocabularyOfLength: self currentState size! !

!HangmanSaver methodsFor: 'algorithm' stamp: 'hjo 1/29/2009 17:52'!
vocabularyOfLength: aSmallInteger 

	^self vocabulary select: [:each| each size = aSmallInteger ]! !
